//------------------------------------------------------------------------------
// :     getdxver.dpr
//
// :      DirectX
//
//
// ,     , 2002
//------------------------------------------------------------------------------
program getdxver;

uses
  windows,
  activex,         //  CoInitialize()
  directdraw,
  directxgraphics,
  directinput,
  directmusic;




//------------------------------------------------------------------------------
// ,    
//------------------------------------------------------------------------------
var
  g_strDXVer: string; //   




//------------------------------------------------------------------------------
// :      GetDXVersion()
// :   DirectX
//------------------------------------------------------------------------------
function GetDXVersion(): DWORD;
var
  //  
  DirectDrawCreate: function( lpGUID: PGUID;
                              out lplpDD: IDirectDraw;
                              pUnkOuter: IUnknown ): HRESULT; stdcall;

  DirectDrawCreateEx: function( lpGUID: PGUID;
                                out lplpDD: IDirectDraw7;
                                const iid: TGUID;
                                pUnkOuter: IUnknown ): HRESULT; stdcall;

  Direct3DCreate8: function ( SDKVersion: Cardinal ): Pointer; stdcall;

  DirectInputCreate: function( hInst: THandle;
                               dwVersion: Cardinal;
                               out ppDI:  IDirectInputA;
                               punkOuter: IUnknown): HRESULT; stdcall;

  hDDrawDLL,
  hDInputDLL,
  hD3D8DLL:  HINST;

  pDD:    IDirectDraw;
  pDD2:   IDirectDraw2;
  pDD7:   IDirectDraw7;
  pD3D8:  IDirect3D8;
  pDI:    IDirectInput;
  pDM:    IDirectMusic;
  pSurf:  IDirectDrawSurface;
  pSurf3: IDirectDrawSurface3;
  pSurf4: IDirectDrawSurface4;

  ddsd: TDDSURFACEDESC;
begin
  Result := $000; //  DirectX

  //----------------------------------------------------------------------------
  //  Game SDK
  //----------------------------------------------------------------------------

  hDDrawDLL := LoadLibrary( 'DDRAW.DLL' );
  if hDDrawDLL = 0 then
     Exit;

  DirectDrawCreate := GetProcAddress( hDDrawDLL, 'DirectDrawCreate' );
  if @DirectDrawCreate = nil then
  begin
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  if FAILED( DirectDrawCreate( nil, pDD, nil ) ) then
  begin
    FreeLibrary( hDDRawDLL );
    Exit;
  end;

  Result := $100; //   ,  Game SDK (DirectX 1)

  //----------------------------------------------------------------------------
  //  DirectX 2
  //----------------------------------------------------------------------------

  //    
  if FAILED( pDD.QueryInterface( IID_IDirectDraw2, pDD2 ) ) then
  begin
    pDD := nil; //    
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  pDD2 := nil;
  Result := $200; //  DirectX 2


  //----------------------------------------------------------------------------
  //  DirectX 3
  //----------------------------------------------------------------------------

  // DirectInput     
  hDInputDLL := LoadLibrary( 'DINPUT.DLL' );
  if hDInputDLL = 0 then
  begin
    // DirectInput ...DirectX 3   
    pDD := nil;
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  DirectInputCreate := GetProcAddress( hDInputDLL, 'DirectInputCreateA' );
  if @DirectInputCreate = nil then
  begin
    pDD := nil;
    FreeLibrary( hDInputDLL );
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  //  SDK    -      
  if FAILED( DirectInputCreate( GetModuleHandle( nil ), $0300, pDI, nil ) ) then
  begin
    pDD := nil;
    FreeLibrary( hDInputDLL );
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  pDI := nil;
  Freelibrary( hDInputDLL );
  Result := $300; //  DirectX 3

  //    3  3b?

  //----------------------------------------------------------------------------
  //  DirectX 5 ( 4   )
  //----------------------------------------------------------------------------

  ZeroMemory( @ddsd, SizeOf( TDDSURFACEDESC ) );
  ddsd.dwSize         := SizeOf( TDDSURFACEDESC );
  ddsd.dwFlags        := DDSD_CAPS;
  ddsd.ddsCaps.dwCaps := DDSCAPS_PRIMARYSURFACE;

  if FAILED( pDD.SetCooperativeLevel( 0, DDSCL_NORMAL ) ) then
  begin
    // !      ... !
    pDD := nil;
    FreeLibrary( hDDrawDLL );
    Result := $000;
    Exit;
  end;

  if FAILED( pDD.CreateSurface( ddsd, pSurf, nil ) ) then
  begin
    pDD := nil;
    FreeLibrary( hDDrawDLL );
    Result := $000;
    Exit;
  end;

  //    IDirectDrawSurface3.  ,  
  //    DirectX 5  
  if FAILED( pSurf.QueryInterface( IID_IDirectDrawSurface3, pSurf3 ) ) then
  begin
    pSurf := nil;
    pDD := nil;
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  pSurf3 := nil;
  Result := $500; //  DirectX 5

  //----------------------------------------------------------------------------
  //  DirectX 6
  //----------------------------------------------------------------------------

  // ,      IDirectDrawSurface4
  if FAILED( pSurf.QueryInterface( IID_IDirectDrawSurface4, pSurf4 ) ) then
  begin
    pSurf := nil;
    pDD := nil;
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  pSurf4 := nil;
  pSurf := nil;
  pDD := nil;
  Result := $600; // E DirectX 6

  //----------------------------------------------------------------------------
  //  DirectX 6.1
  //----------------------------------------------------------------------------

  //      DirectMusic
  CoInitialize( nil );
  if FAILED( CoCreateInstance( CLSID_DirectMusic, nil, CLSCTX_INPROC_SERVER,
                               IID_IDirectMusic, pDM ) ) then
  begin
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  pDM := nil;
  CoUninitialize();
  Result := $601; //  DirectX 6.1

  //----------------------------------------------------------------------------
  //  DirectX 7
  //----------------------------------------------------------------------------

  //  DirectDrawCreateEx()     
  DirectDrawCreateEx := GetProcAddress( hDDrawDLL, 'DirectDrawCreateEx' );
  if @DirectDrawCreateEx = nil then
  begin
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  if FAILED( DirectDrawCreateEx( nil, pDD7, IID_IDirectDraw7, nil ) ) then
  begin
    FreeLibrary( hDDrawDLL );
    Exit;
  end;

  pDD7 := nil;
  FreeLibrary( hDDrawDLL );
  Result := $700; //  DirectX 7

  //----------------------------------------------------------------------------
  //  DirectX 8
  //----------------------------------------------------------------------------

  hD3D8DLL := LoadLibrary( 'D3D8.DLL' );
  if hD3D8DLL = 0 then
     Exit;

  Direct3DCreate8 := GetProcAddress( hD3D8DLL, 'Direct3DCreate8' );
  if @Direct3DCreate8 = nil then
  begin
    FreeLibrary( hD3D8DLL );
    Exit;
  end;

  //  SDK    -      
  pD3D8 := IDirect3D8( Direct3DCreate8( D3D_SDK_VERSION ) );
  if pD3D8 = nil then
  begin
    FreeLibrary( hD3D8DLL );
    Exit;
  end;

  pD3D8 := nil;
  FreeLibrary( hD3D8DLL );

  // !    .    :-)

  //                          
  // 
  //
  //  DirectX         . .    DirectX 8  

  Result := $800;
end;




//------------------------------------------------------------------------------
// :      GetDXRegVersion()
// :   DirectX     Win32 API
//------------------------------------------------------------------------------
function GetDXRegVersion(): string;
var
  hDXKey:     HKEY;
  dwDataType: DWORD;
  dwDataSize: DWORD;
begin
  //        
  if RegOpenKeyEx( HKEY_LOCAL_MACHINE, PChar('SOFTWARE\Microsoft\DirectX'),
                   0, KEY_ALL_ACCESS, hDXKey ) <> ERROR_SUCCESS then
     Exit;

  //    
  SetString( Result, nil, 20 );
  dwDataSize := 20;

  //    Version
  RegQueryValueEx( hDXKey, 'Version', nil, @dwDataType, PByte(Result), @dwDataSize );

  //  
  RegCloseKey( hDXKey );
end;




//------------------------------------------------------------------------------
// :      ()
// :    
//------------------------------------------------------------------------------
begin
  //    DirectX
  case GetDXVersion() of
    $000: g_strDXVer := 'DirectX  ';
    $100: g_strDXVer := ' Game SDK (DirectX 1)';
    $200: g_strDXVer := ' DirectX 2';
    $300: g_strDXVer := ' DirectX 3';
    $500: g_strDXVer := ' DirectX 5';
    $600: g_strDXVer := ' DirectX 6';
    $601: g_strDXVer := ' DirectX 6.1';
    $700: g_strDXVer := ' DirectX 7';
    $800: g_strDXVer := ' DirectX 8  ';
  end;

  //     ,     -
  // HKEY_LOCAL_MACHINE\Software\Microsoft\DirectX,  Version
  g_strDXVer := g_strDXVer + #10 + ': ' + GetDXRegVersion();

  //  
  MessageBox( 0, PChar(g_strDXVer), ' DirectX', MB_ICONINFORMATION );
end.
