//------------------------------------------------------------------------------
// :     main.pas
//
// :   DirectSound   .
//            - 
//
//
// ,     , 2002
//------------------------------------------------------------------------------
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,
  ExtCtrls, Buttons, directsound, Dialogs;

type
  TForm1 = class(TForm)
    btnOpen: TButton;
    odOpenFile: TOpenDialog;
    edFileName: TEdit;
    chbLoop: TCheckBox;
    bbPlay: TBitBtn;
    bbStop: TBitBtn;
    sbVolume: TScrollBar;
    sbPan: TScrollBar;
    Timer1: TTimer;
    procedure btnOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bbPlayClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure bbStopClick(Sender: TObject);
    procedure sbVolumeChange(Sender: TObject);
    procedure sbPanChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  pDS8:  IDirectSound8;

implementation

{$R *.DFM}

uses
  wave;




//------------------------------------------------------------------------------
// ,    
//------------------------------------------------------------------------------
var
  sound: TWave; //    




//------------------------------------------------------------------------------
// :      InitDirectSound()
// :   DirectSound  
//------------------------------------------------------------------------------
function InitDirectSound( hWnd: HWND ): Boolean;
begin
  Result := FALSE;

  //    DirectSound
  if FAILED( DirectSoundCreate8( nil, pDS8, nil ) ) then
     Exit;

  //   .  -  
  if FAILED( pDS8.SetCooperativeLevel( hWnd, DSSCL_PRIORITY ) ) then
     Exit;

  Result := TRUE;
end;




//------------------------------------------------------------------------------
// :      ReleaseDirectSound()
// :    DirectSound
//------------------------------------------------------------------------------
procedure ReleaseDirectSound();
begin
  if pDS8 <> nil then
     pDS8 := nil;
end;




//------------------------------------------------------------------------------
// :      TForm1.FormCreate()
// :   DirectSound   
//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  if not InitDirectSound( Form1.Handle ) then
  begin
     MessageBox( Form1.Handle, '   DirectSound!',
                '!', MB_ICONHAND );
     ReleaseDirectSound();
     Halt;
  end;

  sound := TWave.Create();
end;




//------------------------------------------------------------------------------
// :      TForm1.btnOpenClick()
// :      wav-   UI
//------------------------------------------------------------------------------
procedure TForm1.btnOpenClick(Sender: TObject);
begin
  if odOpenFile.Execute then
  if sound.OpenWaveFile( odOpenFile.FileName ) then  //    
  begin                                              // 
    edFileName.Text := odOpenFile.FileName; //    
    bbPlay.Enabled := TRUE;                 //   - 
  end
  else
  begin
    MessageBox( Form1.Handle, '   ', 'Sound', MB_ICONHAND );
    Close;
  end;
end;




//------------------------------------------------------------------------------
// :      TForm1.bbPlayClick()
// :      
//------------------------------------------------------------------------------
procedure TForm1.bbPlayClick(Sender: TObject);
begin
   //      -    
   if chbLoop.Checked then sound.Play( TRUE )
                      else sound.Play( FALSE );

   btnOpen.Enabled := FALSE; //    - 
   bbPlay.Enabled  := FALSE; //   - 
   bbStop.Enabled  := TRUE;  //   - 
   Timer1.Enabled  := TRUE;  //  
end;




//------------------------------------------------------------------------------
// :      TForm1.bbStopClick()
// :      
//------------------------------------------------------------------------------
procedure TForm1.bbStopClick(Sender: TObject);
begin
  sound.Stop();                  //  
  sound.SetCurrentPosition( 0 ); //     

  bbStop.Enabled  := FALSE;      //  UI...
  bbPlay.Enabled  := TRUE;       // ...
  btnOpen.Enabled := TRUE;       // ...
end;




//------------------------------------------------------------------------------
// :      TForm1.sbVolumeChange()
// :     
//------------------------------------------------------------------------------
procedure TForm1.sbVolumeChange(Sender: TObject);
begin
  sound.SetVolume( sbVolume.Position );
end;




//------------------------------------------------------------------------------
// :      TForm1.sbPanChange()
// :   ""      
//------------------------------------------------------------------------------
procedure TForm1.sbPanChange(Sender: TObject);
begin
  sound.SetPan( sbPan.Position );
end;




//------------------------------------------------------------------------------
// :      TForm1.Timer1Timer()
// :     
//------------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
var
  dwStatus: DWORD;
begin
  //   ,     dwStatus
  sound.GetStatus( dwStatus );

  //    ,   UI   
  if ( dwStatus and DSBSTATUS_PLAYING ) <> DSBSTATUS_PLAYING then
  begin
    bbStop.Enabled  := FALSE; //   - 
    bbPlay.Enabled  := TRUE;  //   - 
    btnOpen.Enabled := TRUE;  //    - 
  end;
end;




//------------------------------------------------------------------------------
// :      TForm1.FormDestroy()
// :      
//------------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  sound.Destroy();
  ReleaseDirectSound();
end;

end.
